---
title: Solana CLI Tool Suite
sidebar_position: 0
sidebar_label: Overview
pagination_label: Solana CLI Tool Suite
---

In this section, we will describe how to use the Solana command-line tools to
create a _wallet_, to send and receive SOL tokens, and to participate in the
cluster by delegating stake.

To interact with a Solana cluster, we will use its command-line interface, also
known as the CLI. We use the command-line because it is the first place the
Solana core team deploys new functionality. The command-line interface is not
necessarily the easiest to use, but it provides the most direct, flexible, and
secure access to your Solana accounts.

## Getting Started

To get started using the Solana Command Line (CLI) tools:

- [Install the Solana CLI Tool Suite](./install.md)
- [Introduction to our CLI conventions](./intro.md)
- [Create a Wallet using the CLI](./wallets/index.md)
- [Choose a Cluster to connect to using the CLI](./examples/choose-a-cluster.md)
